Bumped revision number
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index ed395b2e409c17d44393bbdd0e25d479519fc4a1..ef2fdca96ff7b04a5b2529465d3a85aec93d73d0 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -3,7 +3,7 @@
 # Author: Alan J. Pippin (apippin@pippins.net)
 # Date: 05/17/2009
 #
-  REV=1.0
+  REV=2.3
 #
 # Description: This script wraps a number of linux utilities to
 # create a recipe for ripping protected DVDs, circumventing 
 # Known Issues/Limitations:
 # - Mirror mode is always done in ISO mode
 #
-# Package Dependencies (apt-get install these for example):
-# lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
-#
-# Specific Executable (program) Dependencies (must be found in $PATH):
-# volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
-#
-# Optional Dependencies:
-# lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
-#
-
-##############################################################################
-# Local Machine Settings:
-# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
-# and the local conf file created by each local machine (rip_dvd.conf)
-# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
-# This will allow you to override all the default values to meet your needs
-# in a way that won't get clobbered when you pull updates from my GIT repo.
-##############################################################################
-config="${0%/*}/rip_dvd.conf"
-[ -e "${config}.dist" ] && . ${config}.dist
-[ -e "${config}" ] && . ${config}
+# See the README file for information about the dependencies
+# this script has.
 
 ##############################################################################################
-# Command line processing
+# Global Variables
 ##############################################################################################
 typeset cmd="$0 $*"
 typeset dvdname=""
@@ -50,8 +31,15 @@ typeset dvdpath=""
 typeset aspect=""
 typeset SCALE=""
 typeset CROP=""
-typeset profile="xvidvhq"
+typeset profile="xvidhq"
 typeset extension=""
+typeset mailto=""
+typeset encoder=""
+typeset default_alang="en"
+typeset track=""
+typeset drc="0.0"
+typeset -i default_aid=128
+typeset -i aid_override=-1
 typeset -i force_onepass_mode=0
 typeset -i eject_disk=1
 typeset -i keep_isofile=0
@@ -68,31 +56,73 @@ typeset -i mirror_mode=0
 typeset -i target_bitrate=2000
 typeset -i target_size=0
 typeset -i audio_2ch=0
+typeset -i audio_6ch=1
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
+typeset -i custom_bitrate=0
+typeset -i custom_audio_2ch=0
+typeset -i custom_audio_6ch=0
+
+##############################################################################
+# Local Machine Settings:
+# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
+# and the local conf file created by each local machine (rip_dvd.conf)
+# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
+# This will allow you to override all the default values to meet your needs
+# in a way that won't get clobbered when you pull updates from my GIT repo.
+##############################################################################
+config="${0%/*}/rip_dvd.conf"
+
+# The config file will be searched for in the following location order:
+found_config=0
+
+# 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
+[ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
+
+# 2) /path/to/rip_dvd/script/rip_dvd.conf
+[ -e "${config}" ] && found_config=1 && . "${config}"
+
+# 3) /etc/rip_dvd.conf
+[ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
 
-while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
+# 4) $PWD/rip_dvd.conf
+[ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
+
+# Check to make sure we found the config file
+if [ $found_config -eq 0 ]; then
+  echo "-E- Unable to find the rip_dvd.conf file: $config"
+  exit 1
+fi
+
+##############################################################################################
+# Command line processing
+##############################################################################################
+while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
         (d)     dest=$OPTARG;;
-        (b)     target_bitrate=$OPTARG;;
+        (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
        (s)     target_size=$OPTARG;;
-        (2)     audio_2ch=1;;
+        (2)     audio_2ch=1; custom_audio_2ch=1;;
+        (6)     audio_6ch=1; custom_audio_6ch=1;;
         (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
         (f)     make_final_dest_folder=1;; 
-        (x)     make_final_dest_comp=1;;
+        (z)     make_final_dest_comp=1;;
+       (e)     encoder=$OPTARG;;
         (m)     mirror_mode=1;;
         (k)     keep_intermediate_files=1;;
         (t)     feature_title_override=$OPTARG;;
        (a)     aspect=$OPTARG;;
        (p)     profile=$OPTARG;;
-       (e)     extension=$OPTARG;;
+       (x)     extension=$OPTARG;;
        (j)     eject_disk=$OPTARG;;
-        (w)     set -$opt;;
+       (l)     aid_override=$OPTARG;;
+       (r)     drc=$OPTARG;;
+        (w)     set -x;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
@@ -108,20 +138,23 @@ function usage() {
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
-    echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
-    echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
-    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
-    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
+    echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
+    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
-    #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
-    #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
-    #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
-    echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
+    echo >&2 "                 Handbrake Only Encoder Profiles:"
+    echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
+    echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
     echo >&2 "                 The default operation is non-mirror mode where only the main"
@@ -129,11 +162,12 @@ function usage() {
     echo >&2 "   -v            Make the final image a DVD VOB file"
     echo >&2 "   -i            Make the final image a DVD ISO file"
     echo >&2 "   -f            Make the final image a DVD folder"
-    echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
-    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
+    echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
+    echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
+    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
-    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
+    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
     echo >&2 "   -j <n>        Eject the disk:"
@@ -143,9 +177,13 @@ function usage() {
     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
+    echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
+    echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
+    echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
-    echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
+    echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
+    echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
     echo >&2 ""
@@ -163,30 +201,49 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
-  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
-  usage
+if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
+   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
+    # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
+    make_final_dest_comp=1
 fi
 
-if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
-  echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
+if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
+  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
-if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
-   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
-  echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
+if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
+  echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
   usage
 fi
 
 if [ $mirror_mode -eq 1 ]; then
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
-    echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
+    echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
     usage
   fi
 fi
 
+# Make handbrake the default encoder if not specified and we can find it
+if [ -z "$encoder" ]; then
+  encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
+  [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
+fi
+
+# Sanity check the profile selection
+if [[ "$encoder" == "mencoder" ]]; then
+  [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
+fi
+
+if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
+  echo "-E- Invalid encoder specified: $encoder"
+  exit 1
+fi
+
 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
 if [ "$aspect" != "" ]; then
   echo "$aspect" | grep -q "x"
@@ -196,13 +253,18 @@ if [ "$aspect" != "" ]; then
   fi
   echo "$aspect" | grep -q ":"
   if [ $? != 0 ]; then
-    SCALE=",scale -zoom -sws 9 -xy $aspect"
+    [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
+    [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
   else
-    SCALE=",scale=$aspect"
+    [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
+    if [ "$encoder" == "handbrake" ]; then
+       WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
+       HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
+       SCALE="-w $WIDTH -l $HEIGHT"
+    fi
   fi
 fi
 
-
 # Sanity Check - Key executables
 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
@@ -212,11 +274,19 @@ fi
 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
+[[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
+[[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
 
 ##############################################################################################
 
 typeset -i ripdvd
 if [ -z "$dvdname" ]; then
+
   # make sure the DVD device is accessible
   volname $dev > /dev/null 2>&1
   if [ $? != 0 ]; then
@@ -226,7 +296,9 @@ if [ -z "$dvdname" ]; then
   # now capture the volume name from the device
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
+
 else 
+
   # check to see if dvdname is a full path to a real directory
   # if it is, set dvdname and dvdpath appropriately
   if [ -d "$dvdname" ]; then
@@ -271,15 +343,36 @@ else
       valid_file=1
     fi    
 
+    # check to see if dvdname is a full path to an ISO file
+    # if it is, set dvdname and isofile appropriately
+    file "$dvdname" | grep -q -e "VOB"
+    if [ $? == 0 ]; then
+      # It is a valid VOB file, now strip the extension off our dvdname
+      vobfile="$dvdname"
+      dvdname=`basename "$dvdname"`
+      dvdname=${dvdname%.[^.]*}
+      keep_vobfile=1
+      valid_file=1
+    fi    
+
     # If we didn't find a handler for the file above, complain
     if [ $valid_file -eq 0 ]; then
       echo "-E- Unsupported file type: $vobfile"
       exit 1
     fi
+
+  # Throw an error if we can't find what the -n option is pointing to
+  else 
+    echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
+    exit 1
   fi
+
+  # Set the ripdvd flag to false since we aren't ripping a DVD disk
   ripdvd=0
-  # Since we aren't ripping a DVD disk, don't eject anything
+
+  # Since we aren't ripping a DVD disk, don't eject anything either
   eject_disk=0
+
 fi
 
 # remove bad characters from the dvdname
@@ -368,8 +461,218 @@ trap cleanup EXIT
 # processing functions
 ##############################################################################################
 
-# encode the vob file into a compressed file format
-function encode_vob_file {
+# encode the vob file into a compressed file format using handbrake
+function encode_vob_file_handbrake {
+  
+  # declare some globals
+  typeset handbrake_cli=""
+  typeset handbrake_video_encoder_opts=""
+  typeset filetype=""
+  typeset handbrake_audio_opts=""
+  typeset hb_profile=""
+  typeset SIZE=""
+
+  # Set a variable that we will use later to determine if we found a handler for $profile or not
+  typeset -i found_profile=0    
+
+  # For a given profile, to override the 2 pass behavior to be single pass,
+  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
+  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  PASSES="-2"
+
+  # Set our DRC option
+  DRC="-D $drc"
+
+  if [ $target_size -ne 0 ]; then
+    SIZE="-S $target_size"
+  fi 
+
+  # Check the global force_onepass_mode. If it is set, change our variables appropriately
+  # to force 1-pass encoding across all profiles.
+  if [ $force_onepass_mode -eq 1 ]; then
+    PASSES=""
+  fi
+
+  # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
+  get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
+
+  # XVID profile
+  if [[ "$profile" =~ "xvid" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_xvid"
+    final_output_file="$dest/$dvdname.avi"
+    filetype="avi"
+
+    # Very High Quality (16fps)
+    if [ "$profile" == "xvidvhq" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e xvid"
+      handbrake_opts[3]="-T"
+      handbrake_opts[4]="-5"
+      handbrake_opts[5]="-8"
+    fi
+    # High Quality (20fps)
+    if [ "$profile" == "xvidhq" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e ffmpeg"
+      handbrake_opts[3]="-T"
+      handbrake_opts[4]="-5"
+    fi
+    # Fast (28fps)
+    if [ "$profile" == "xvid" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e ffmpeg"
+      handbrake_opts[3]="-T"
+    fi
+  fi
+
+  # MP4 profile
+  if [[ "$profile" =~ "mp4" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+
+    # Handle custom parameter overrides
+    if [ $custom_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
+
+    # Very High Quality
+    if [ "$profile" == "mp4vhq" ]; then
+      profile="hb_High_Profile"
+    fi
+    # High Quality
+    if [ "$profile" == "mp4hq" ]; then
+      profile="hb_Normal"
+    fi
+    # Fast
+    if [ "$profile" == "mp4" ]; then
+      profile="hb_Classic"
+    fi
+  fi
+
+  # iphone and ipod MP4 profiles
+  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+
+    # Handle custom parameter overrides
+    if [ $custom_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
+
+    # iphone
+    if [ "$profile" == "iphone" ]; then
+      profile="hb_iPhone_&_iPod_Touch"
+    fi
+    # ipod
+    if [ "$profile" == "ipod" ]; then
+      profile="hb_iPod"
+    fi
+
+  fi
+  
+  # Predefined Handbrake Profile Handling
+  if [[ "$profile" =~ "hb" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+
+    # Handle custom parameter overrides
+    if [ $custom_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
+    
+    # extract the HandBrake Profile name from $profile
+    hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
+  fi
+
+  # Make sure we found a handler for the given profile
+  if [ $found_profile -eq 0 ]; then
+    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
+  fi
+
+  # setup our audio option
+  if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
+    handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
+  fi
+  if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
+    handbrake_audio_opts="-E ac3 -6 auto"
+  fi
+  if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
+    handbrake_audio_opts="-E faac -6 dpl2"
+  fi
+  if [ -n "$track" ]; then
+    handbrake_audio_opts="$handbrake_audio_opts -a $track"
+  fi
+
+  # Convert our array of opts into a string
+  for OPTS in "${video_encoder_opts[@]}"; do 
+    handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
+  done
+  if [ -n "$handbrake_video_encoder_opts" ]; then
+    handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
+  fi
+  for OPTS in "${handbrake_opts[@]}"; do 
+    handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
+  done
+
+  # Append "global" command line options
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
+
+  # Execute the handbrake command to encode the video
+  # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
+  # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
+  if [ -n "$hb_profile" ]; then
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  else 
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  fi
+  if [ $handbrake_retval != 0 ]; then
+    fatal_and_exit "-E- Unhandled handbrake error"
+  fi
+
+  # Concatenate the encode log to our main log file, greping out unwanted lines
+  cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
+  cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
+  cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
+}
+
+# encode the vob file into a compressed file format using mencoder
+function encode_vob_file_mencoder {
 
   # Set a variable that we will use later to determine if we found a handler for $profile or not
   typeset -i found_profile=0
@@ -392,7 +695,7 @@ function encode_vob_file {
   fi
 
   # XVID profile
-  if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
+  if [[ "$profile" =~ "xvid" ]]; then
     found_profile=1
     final_output_file="$dest/$dvdname.avi"
     mencoder_general_opts="$lang_opts $passlogfile_opt"
@@ -448,73 +751,6 @@ function encode_vob_file {
  
   fi
 
-  # MP4 encoding profiles
-  # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
-  if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
-    found_profile=1
-    final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="$lang_opts $passlogfile_opt"
-    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
-    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
-
-    # Very High Quality (6fps)
-    if [ "$profile" == "mp4vhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=6"
-      video_encoder_opts[3]="frameref=5"
-      video_encoder_opts[4]="bframes=3"
-      video_encoder_opts[5]="8x8dct"
-      video_encoder_opts[6]="me=umh"
-      video_encoder_opts[7]="b_pyramid"
-      video_encoder_opts[8]="weight_b"
-      video_encoder_opts[9]="partitions=all" 
-    fi
-    # High Quality (13fps)
-    if [ "$profile" == "mp4hq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=5"
-      video_encoder_opts[3]="frameref=2"
-      video_encoder_opts[4]="bframes=3"
-      video_encoder_opts[5]="8x8dct"
-      video_encoder_opts[6]="b_pyramid"
-      video_encoder_opts[7]="weight_b"
-    fi
-    # Fast (17fps)
-    if [ "$profile" == "mp4" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=4"
-      video_encoder_opts[3]="bframes=2"
-      video_encoder_opts[4]="b_pyramid"
-      video_encoder_opts[5]="weight_b"
-    fi
-
-    for OPTS in "${video_encoder_opts[@]}"; do
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    if [ $audio_2ch -eq 0 ]; then
-      # These options produce good 6 channel audio for linux and windows
-      #mencoder_audio_opts="-oac copy"
-      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
-      #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
-      #mencoder_audioch_opts[1]="-af channels=6"
-      #mencoder_audioch_opts[2]=""
-      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 6 -srate 48000"
-    else
-      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
-      #mencoder_audioch_opts[0]=""
-      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 2 -srate 48000"
-    fi
-
-  fi
-
   # iphone and ipod MP4 profiles
   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
     found_profile=1
@@ -763,17 +999,22 @@ function get_audio_id_from_iso {
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
   iso="$1"
   aidcheck=`tempfile`
-  aid=128
-  mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
-  grep -q "aid: $aid" $aidcheck
-  while [ $? == 1 ] && [ $aid -lt 159 ]; do
-    (( aid = aid + 1 ))
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
     grep -q "aid: $aid" $aidcheck
-  done
-  [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "aid: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else
+    aid=$aid_override
+  fi
   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
-  lang_opts="-aid $aid -alang en"
+  lang_opts="-aid $aid -alang $alang"
 }
 
 function get_crop_from_iso { 
@@ -826,22 +1067,69 @@ function get_crop_from_vob {
   echo "   Setting mencoder crop filter to: $CROP"
 }
 
+function get_audio_track_from_vob {
+  # Adjust our audio ID to find the english audio stream
+  # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  vob="$1"
+  handbrake_cli="$2"
+  aidcheck=`tempfile`
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
+    grep -q "Found audio stream: $aid" $aidcheck
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "Found audio stream: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else 
+    aid=$aid_override
+  fi
+  # Now that we've found the right audio id, find the corresponding audio track in HandBrake
+
+  # convert the aid we found into hex
+  aid_hex=`echo "obase=16; $aid" | bc`
+  
+  # extract the audio streams in the vob
+  #ffmpeg -i "$vob" > $aidcheck 2>&1
+  $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
+  
+  # find the stream that matches our aid
+  #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
+  #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
+  stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
+  # extract the track number that handbrake uses
+  #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
+  track=`expr match "$stream" '^\([0-9]*\):'`
+
+  if [ -n "$track" ]; then   
+    echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
+  fi
+}
+
 function get_audio_id_from_vob {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
   vob="$1"
   aidcheck=`tempfile`
-  aid=128
-  mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
-  grep -q "Found audio stream: $aid" $aidcheck
-  while [ $? == 1 ] && [ $aid -lt 159 ]; do
-    (( aid = aid + 1 ))
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
     grep -q "Found audio stream: $aid" $aidcheck
-  done
-  [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "Found audio stream: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else 
+    aid=$aid_override
+  fi
   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
-  lang_opts="-aid $aid -alang en"
+  lang_opts="-aid $aid -alang $alang"
 }
 
 function check_vob_for_corrupted_start {
@@ -954,6 +1242,7 @@ function calculate_bitrate_from_target_size {
   if [ $target_size -ne 0 ]; then
     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
+    custom_bitrate=1
     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
   fi
 }
@@ -1227,11 +1516,13 @@ if [ $mirror_mode -eq 0 ]; then
       remove_intermediate_iso_file
 
     else
-      echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
-      # get our audio id from the VOB file
-      get_audio_id_from_vob "$vobfile"
-      # get the crop value from the VOB
-      get_crop_from_vob
+      if [ "$encoder" != "handbrake" ]; then 
+        echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
+        # get our audio id from the VOB file
+        get_audio_id_from_vob "$vobfile"
+        # get the crop value from the VOB
+        get_crop_from_vob
+      fi
     fi
 
     # eject the DVD disk since we are finished with it
@@ -1239,13 +1530,18 @@ if [ $mirror_mode -eq 0 ]; then
 
     # encode the VOB file to a compressed file format
     if [ $make_final_dest_comp -eq 1 ]; then
-      echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
+      echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
 
       # determine what our bitrate needs to be if a target size was specified instead
       calculate_bitrate_from_target_size        
      
       # encode the vob file into a compressed file format
-      encode_vob_file
+      if [[ "$encoder" == "mencoder" ]]; then 
+        encode_vob_file_mencoder
+      fi
+      if [[ "$encoder" == "handbrake" ]]; then
+        encode_vob_file_handbrake
+      fi
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
@@ -1327,4 +1623,4 @@ if [ $mirror_mode -eq 0 ]; then
 
 fi
 
-##############################################################################################
\ No newline at end of file
+##############################################################################################